////////////////////////////////////////////////////////////////////////////////
// Filename: light_ps.hlsl
////////////////////////////////////////////////////////////////////////////////


/////////////
// GLOBALS //
/////////////
Texture2D shaderTexture;
SamplerState SampleType;


//////////////////////
// CONSTANT BUFFERS //
//////////////////////
cbuffer LightBuffer
{
    float4 diffuseColor;
    float3 lightDirection;
    float padding;
};


//////////////
// TYPEDEFS //
//////////////
struct PixelInputType
{
    float4 position : SV_POSITION;
    float2 tex : TEXCOORD0;
	float3 normal : NORMAL;
};


////////////////////////////////////////////////////////////////////////////////
// Pixel Shader
////////////////////////////////////////////////////////////////////////////////
float4 LightPixelShader(PixelInputType input) : SV_TARGET
{
	float4 textureColor;
	float3 lightDir;
	float lightIntensity;
	float4 color;

	//  ؽó ǥ ġ ÷ Ͽ ؽó ȼ  øմϴ.
	textureColor = shaderTexture.Sample(SampleType, input.tex);

	//     ŵϴ.
	lightDir = -lightDirection;

	//  ȼ   մϴ.
	lightIntensity = saturate(dot(input.normal, lightDir));

	// Ȯ    翡   Ȯ  մϴ.
	color = saturate(diffuseColor * lightIntensity);

	// ؽó ȼ Է     ϴ.
	color = color * textureColor;

    return color;
}