#include "stdafx.h"
#include "D3DClass.h"
#include "TextClass.h"
#include "FontClass.h"
#include "ShaderManagerClass.h"
#include "minimapclass.h"
#include "userinterfaceclass.h"


UserInterfaceClass::UserInterfaceClass()
{
}


UserInterfaceClass::UserInterfaceClass(const UserInterfaceClass& other)
{
}


UserInterfaceClass::~UserInterfaceClass()
{
}


bool UserInterfaceClass::Initialize(D3DClass* Direct3D, int screenHeight, int screenWidth)
{
	// ù ° ۲ ü մϴ.
	m_Font1 = new FontClass;
	if(!m_Font1)
	{
		return false;
	}

	// // ù ° ۲ ü ʱȭ մϴ.
	if(!m_Font1->Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), "../Dx11Terrain_24/data/font/font01.txt", 
								 "../Dx11Terrain_24/data/font/font01.tga", 32.0f, 3))
	{
		return false;
	}

	// fps ڿ  ؽƮ ü մϴ.
	m_FpsString = new TextClass;
	if(!m_FpsString)
	{
		return false;
	}

	// fps ؽƮ ڿ ʱȭ մϴ.
	if(!m_FpsString->Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
								"Fps: 0", 10, 50, 0.0f, 1.0f, 0.0f))
	{
		return false;
	}

	//   fps ʱ մϴ.
	m_previousFps = -1;

	//  ī   մϴ.
	char videoCard[128] = { 0, };
	char videoString[144] = { 0, };
	int videoMemory = 0;
	char memoryString[32] = { 0, };
	char tempString[16] = { 0, };

	// ī  ڿ մϴ.
	Direct3D->GetVideoCardInfo(videoCard, videoMemory);
	strcpy_s(videoString, "Video Card: ");
	strcat_s(videoString, videoCard);
	
	_itoa_s(videoMemory, tempString, 10);
	strcpy_s(memoryString, "Video Memory: ");
	strcat_s(memoryString, tempString);
	strcat_s(memoryString, " MB");

	//  ڿ  ؽƮ ü մϴ.
	m_VideoStrings = new TextClass[2];
	if(!m_VideoStrings)
	{
		return false;
	}

	// ġ ؽƮ ڿ ʱȭ մϴ.
	if (!m_VideoStrings[0].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 256, false, m_Font1, 
									  videoString, 10, 10, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}
	
	if (!m_VideoStrings[1].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 32, false, m_Font1, 
									  memoryString, 10, 30, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}
	
	// ġ ڿ  ؽƮ ü 迭 մϴ.
	m_PositionStrings = new TextClass[6];
	if(!m_PositionStrings)
	{
		return false;
	}

	// ġ ؽƮ ڿ ʱȭ մϴ.
	if (!m_PositionStrings[0].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
										 "X: 0",  10, 100, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	if (!m_PositionStrings[1].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
										 "Y: 0",  10, 120, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}
	
	if (!m_PositionStrings[2].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
										 "Z: 0",  10, 140, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	if (!m_PositionStrings[3].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
										 "rX: 0", 10, 180, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	if (!m_PositionStrings[4].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
										 "rY: 0", 10, 200, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}
	
	if (!m_PositionStrings[5].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 16, false, m_Font1, 
										 "rZ: 0", 10, 220, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	//   ġ ʱȭմϴ.
	m_previousPosition = { 0.0f, 0.0f, 0.0f };
	m_previousRotation = { 0.0f, 0.0f, 0.0f };

	//  īƮ ڿ  ؽƮ ü մϴ.
	m_RenderCountStrings = new TextClass[3];
	if(!m_RenderCountStrings)
	{
		return false;
	}

	//  īƮ ڿ ʱȭմϴ.
	if(!m_RenderCountStrings[0].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 32, false, m_Font1,
											"Polys Drawn: 0", 10, 260, 1.0f, 1.0f, 1.0f))
	{ 
		return false; 
	}

	if(!m_RenderCountStrings[1].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 32, false, m_Font1,
											"Cells Drawn: 0", 10, 280, 1.0f, 1.0f, 1.0f))
	{ 
		return false; 
	}

	if(!m_RenderCountStrings[2].Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 32, false, m_Font1,
											"Cells Culled: 0", 10, 300, 1.0f, 1.0f, 1.0f))
	{ 
		return false; 
	}
	
	// ̴  ü մϴ..
	m_MiniMap = new MiniMapClass;
	if(!m_MiniMap)
	{
		return false;
	}

	// ̴  ü ʱȭմϴ.
	if(!m_MiniMap->Initialize(Direct3D->GetDevice(), Direct3D->GetDeviceContext(), screenWidth, screenHeight, 1025, 1025))
	{
		return false;
	}
	
	return true;
}


void UserInterfaceClass::Shutdown()
{
	// ̴  ü մϴ.
	if(m_MiniMap)
	{
		m_MiniMap->Shutdown();
		delete m_MiniMap;
		m_MiniMap = 0;
	}
	
	//  īƮ ڿ մϴ.
	if(m_RenderCountStrings)
	{
		m_RenderCountStrings[0].Shutdown();
		m_RenderCountStrings[1].Shutdown();
		m_RenderCountStrings[2].Shutdown();

		delete [] m_RenderCountStrings;
		m_RenderCountStrings = 0;
	}
	
	// ġ ؽƮ ڿ մϴ.
	if(m_PositionStrings)
	{
		m_PositionStrings[0].Shutdown();
		m_PositionStrings[1].Shutdown();
		m_PositionStrings[2].Shutdown();
		m_PositionStrings[3].Shutdown();
		m_PositionStrings[4].Shutdown();
		m_PositionStrings[5].Shutdown();

		delete [] m_PositionStrings;
		m_PositionStrings = 0;
	}

	// ġ ؽƮ ڿ մϴ.
	if(m_VideoStrings)
	{
		m_VideoStrings[0].Shutdown();
		m_VideoStrings[1].Shutdown();

		delete [] m_VideoStrings;
		m_VideoStrings = 0;
	}
	
	// fps ؽƮ ڿ մϴ.
	if(m_FpsString)
	{
		m_FpsString->Shutdown();
		delete m_FpsString;
		m_FpsString = 0;
	}

	// ۲ ü մϴ.
	if(m_Font1)
	{
		m_Font1->Shutdown();
		delete m_Font1;
		m_Font1 = 0;
	}
}


bool UserInterfaceClass::Frame(ID3D11DeviceContext* deviceContext, int fps, XMFLOAT3 pos, XMFLOAT3 rot)
{
	// fps ڿ Ʈ մϴ.
	if(!UpdateFpsString(deviceContext, fps))
	{
		return false;
	}

	// ġ ڿ Ʈ մϴ.
	if(!UpdatePositionStrings(deviceContext, pos, rot))
	{
		return false;
	}

	// ̴  ġ ǥñ⸦ Ʈմϴ.
	m_MiniMap->PositionUpdate(pos.x, pos.z);

	return true;
}


bool UserInterfaceClass::Render(D3DClass* Direct3D, ShaderManagerClass* ShaderManager, XMMATRIX worldMatrix, XMMATRIX viewMatrix, XMMATRIX orthoMatrix)
{
	// Z ۸    ȰȭϿ 2D  մϴ.
	Direct3D->TurnZBufferOff();
	Direct3D->EnableAlphaBlending();

	// fps ڿ  մϴ.
	m_FpsString->Render(Direct3D->GetDeviceContext(), ShaderManager, worldMatrix, viewMatrix, orthoMatrix, m_Font1->GetTexture());

	//  ī ڿ մϴ.
	m_VideoStrings[0].Render(Direct3D->GetDeviceContext(), ShaderManager, worldMatrix, viewMatrix, orthoMatrix, m_Font1->GetTexture());
	m_VideoStrings[1].Render(Direct3D->GetDeviceContext(), ShaderManager, worldMatrix, viewMatrix, orthoMatrix, m_Font1->GetTexture());

	// ġ ȸ ڿ մϴ.
	for(int i=0; i<6; i++)
	{
		m_PositionStrings[i].Render(Direct3D->GetDeviceContext(), ShaderManager, worldMatrix, viewMatrix, orthoMatrix, m_Font1->GetTexture());
	}

	//  īƮ ڿ մϴ.
	for(int i=0; i<3; i++)
	{
		m_RenderCountStrings[i].Render(Direct3D->GetDeviceContext(), ShaderManager, worldMatrix, viewMatrix, orthoMatrix, m_Font1->GetTexture());
	}
	
	// ؽƮ ǾǷ   ϴ.
	Direct3D->DisableAlphaBlending();

	// ̴  մϴ.
	if(!m_MiniMap->Render(Direct3D->GetDeviceContext(), ShaderManager, worldMatrix, viewMatrix, orthoMatrix))
	{
		return false;
	}
	// 2D  ϷǸ Z ۸ ٽ ѽʽÿ.
	Direct3D->TurnZBufferOn();

	return true;
}


bool UserInterfaceClass::UpdateFpsString(ID3D11DeviceContext* deviceContext, int fps)
{
	// ؽƮ ڿ Ʈ ʿ䰡     fps  Ȯմϴ.
	if(m_previousFps == fps)
	{
		return true;
	}

	//   Ȯϱ  fps մϴ.
	m_previousFps = fps;

	// fps 100,000 ̸ Դϴ.
	if(fps > 99999)
	{
		fps = 99999;
	}

	// fps  ڿ  ȯմϴ.
	char tempString[16] = { 0, };
	_itoa_s(fps, tempString, 10);

	// fps ڿ մϴ.
	char finalString[16] = { 0, };
	strcpy_s(finalString, "Fps: ");
	strcat_s(finalString, tempString);

	float red = 0.0f;
	float green = 0.0f;
	float blue = 0.0f;

	// fps 60 ̸̻ fps   մϴ.
	if(fps >= 60)
	{
		red = 0.0f;
		green = 1.0f;
		blue = 0.0f;
	}

	// fps 60 ̸̸ fps   մϴ.
	if(fps < 60)
	{
		red = 1.0f;
		green = 1.0f;
		blue = 0.0f;
	}

	// fps 30 ̸̸ fps   մϴ.
	if(fps < 30)
	{
		red = 1.0f;
		green = 0.0f;
		blue = 0.0f;
	}

	//   ۸  ڿ  Ʈ մϴ.
	if(!m_FpsString->UpdateSentence(deviceContext, m_Font1, finalString, 10, 50, red, green, blue))
	{
		return false;
	}

	return true;
}


bool UserInterfaceClass::UpdatePositionStrings(ID3D11DeviceContext* deviceContext, XMFLOAT3 pos, XMFLOAT3 rot)
{
	XMFLOAT3 position = pos;
	XMFLOAT3 rotation = rot;
	char tempString[16] = { 0, };
	char finalString[16] = { 0, };

	//    ķ   ġ ڿ Ʈ մϴ.
	if(position.x != m_previousPosition.x)
	{
		m_previousPosition.x = position.x;
		_itoa_s((int)(position.x), tempString, 10);
		strcpy_s(finalString, "X: ");
		strcat_s(finalString, tempString);
		if (!m_PositionStrings[0].UpdateSentence(deviceContext, m_Font1, finalString, 10, 100, 1.0f, 1.0f, 1.0f))
		{
			return false;
		}
	}

	if(position.y != m_previousPosition.y)
	{
		m_previousPosition.y = position.y;
		_itoa_s((int)(position.y), tempString, 10);
		strcpy_s(finalString, "Y: ");
		strcat_s(finalString, tempString);
		if (!m_PositionStrings[1].UpdateSentence(deviceContext, m_Font1, finalString, 10, 120, 1.0f, 1.0f, 1.0f))
		{
			return false;
		}
	}

	if(position.z != m_previousPosition.z)
	{
		m_previousPosition.z = position.z;
		_itoa_s((int)(position.z), tempString, 10);
		strcpy_s(finalString, "Z: ");
		strcat_s(finalString, tempString);
		if (!m_PositionStrings[2].UpdateSentence(deviceContext, m_Font1, finalString, 10, 140, 1.0f, 1.0f, 1.0f))
		{
			return false;
		}
	}

	if(rotation.x != m_previousRotation.x)
	{
		m_previousRotation.x = rotation.x;
		_itoa_s((int)(rotation.x), tempString, 10);
		strcpy_s(finalString, "rX: ");
		strcat_s(finalString, tempString);
		if (!m_PositionStrings[3].UpdateSentence(deviceContext, m_Font1, finalString, 10, 180, 1.0f, 1.0f, 1.0f))
		{
			return false;
		}
	}

	if(rotation.y != m_previousRotation.y)
	{
		m_previousRotation.y = rotation.y;
		_itoa_s((int)(rotation.y), tempString, 10);
		strcpy_s(finalString, "rY: ");
		strcat_s(finalString, tempString);
		if (!m_PositionStrings[4].UpdateSentence(deviceContext, m_Font1, finalString, 10, 200, 1.0f, 1.0f, 1.0f))
		{
			return false;
		}
	}

	if(rotation.z != m_previousRotation.z)
	{
		m_previousRotation.z = rotation.z;
		_itoa_s((int)(rotation.z), tempString, 10);
		strcpy_s(finalString, "rZ: ");
		strcat_s(finalString, tempString);
		if (!m_PositionStrings[5].UpdateSentence(deviceContext, m_Font1, finalString, 10, 220, 1.0f, 1.0f, 1.0f))
		{
			return false;
		}
	}

	return true;
}


bool UserInterfaceClass::UpdateRenderCounts(ID3D11DeviceContext* deviceContext, int renderCount, int nodesDrawn, int nodesCulled)
{
	char tempString[32] = { 0, };
	char finalString[32] = { 0, };


	//    ڿ  ȯմϴ.
	_itoa_s(renderCount, tempString, 10);

	//  īƮ ڿ մϴ.
	strcpy_s(finalString, "Polys Drawn: ");
	strcat_s(finalString, tempString);

	//   ۸  ڿ  Ʈմϴ.
	if (!m_RenderCountStrings[0].UpdateSentence(deviceContext, m_Font1, finalString, 10, 260, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	//  ׷  ڿ  ȯմϴ.
	_itoa_s(nodesDrawn, tempString, 10);

	//  ׷ ڿ մϴ.
	ZeroMemory(finalString, sizeof(tempString));
	strcpy_s(finalString, "Cells Drawn: ");
	strcat_s(finalString, tempString);

	//   ۸  ڿ  Ʈմϴ.
	if (!m_RenderCountStrings[1].UpdateSentence(deviceContext, m_Font1, finalString, 10, 280, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	//  ߷   ڿ  ȯմϴ.
	_itoa_s(nodesCulled, tempString, 10);

	//  ߷  ڿ մϴ.
	ZeroMemory(finalString, sizeof(tempString));
	strcpy_s(finalString, "Cells Culled: ");
	strcat_s(finalString, tempString);

	//   ۸  ڿ  Ʈմϴ.
	if (!m_RenderCountStrings[2].UpdateSentence(deviceContext, m_Font1, finalString, 10, 300, 1.0f, 1.0f, 1.0f))
	{
		return false;
	}

	return true;
}